
/**
 * Title:        Visualisation<p>
 * Description:  An implementation of some search result visualisations
 * <p>
 * Copyright:    Copyright (c) Matthew Carey<p>
 * Company:      <p>
 * @author Matthew Carey
 * @version 1.0
 */
package vishnu.testvis.evaluate;
import vishnu.testvis.object.*;
import vishnu.testvis.visual.*;
import java.io.*;
import java.util.*;
import java.text.*;

public class Logging
{
    private Vishnu displayFrame;
    private String _id;
    String filename;
    PrintWriter outlog;
    long startmilli;

    public Logging(String id, String path, Vishnu d)
    {
        displayFrame = d;
        DateFormat longTime = DateFormat.getDateTimeInstance(DateFormat.FULL,DateFormat.FULL);
        DateFormat shortTime = DateFormat.getDateTimeInstance(DateFormat.SHORT,DateFormat.SHORT);
        Date todayDate = new Date();
        String node = replace_chars(
            replace_chars(id + "_" + shortTime.format(new Date()) + ".xml"," ","_"),
            "/:","-");
        if (null==path)filename = node;
        else filename = path + node;
        System.out.println(filename);
        //Properties p = d.getProperties();
        _id = id;
        long Time;
        try
        {
            /*outlog =
                new PrintWriter(
                    new BufferedWriter(
                        new FileWriter(filename)));*/
            File target = new File(filename);
		    FileWriter fw = new FileWriter(target);
		    outlog = new PrintWriter(fw,true);
		
		    outlog.println("<LOG>");
            startmilli=System.currentTimeMillis();
            log("ID",_id);
            log("DATE_AND_TIME",longTime.format(todayDate));
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
    }

    private String replace_chars(String target,String oldch, String newch)
    {
        StringTokenizer tokenizer = new StringTokenizer(target,oldch);
        StringBuffer buff = new StringBuffer();

        while(tokenizer.hasMoreElements())
        {
            if(buff.length()>0)
                buff.append(newch);
            buff.append(tokenizer.nextToken());
        }
        return buff.toString();
    }
    
    public void log(String tag, String value)
    {
        String out ="<" + tag + " MILLISECS = \"" +
            Long.toString(System.currentTimeMillis()-startmilli) + "\">" +  value + "</" + tag + ">";
        outlog.println(out);
    }
    

    public void log(String tag)
    {
        String out ="<" + tag + " MILLISECS = \"" +
            Long.toString(System.currentTimeMillis()-startmilli) + "\"/>";
        outlog.println(out);
    }

    public void endsection(String tag)
    {
        outlog.println("</"+tag+">");
    }

    public void startsection(String tag)
    {
        outlog.println("<"+tag+">");
    }

    public void logout()
    {
        log("LOGOUT",_id);
        outlog.println("</LOG>");
        outlog.close();
    }
}
