package vishnu.testvis.object;
import java.io.*;
import java.net.*;
import java.util.*;
import vishnu.datablock.*;
import vishnu.testvis.visual.*;

public class Engine
{
    Vishnu display;
    String servlet;

    public Engine() {
    }

    public Engine(Vishnu display)
    {
	this.setDisplay(display);
	
    }
    
    public void setDisplay(Vishnu display) {
	this.display = display;
	servlet = display.server_address;
	System.out.println("servlet= "+servlet);

    }
    
    public Vector getCollections(Vector q)
    {
	Vector c = null;// = new Vector();
	try{
	    URLConnection con = getConnection();
            System.out.println("Sending request for collections");
	    sendObject(con,q);
	    c = (Vector)receiveObject(con);
	} catch( Exception ex) {System.out.println(ex);}
	return c;
    }
    
    public DataBlock getData(String query, String collection, String view)
    {
        DataBlock data = null;
        Vector q = new Vector();
	q.addElement("search");
        q.addElement(query);
	q.addElement(collection);
	q.addElement(view);
	

        try{
            URLConnection con = getConnection();
            sendObject(con,q);
	    Vector v = (Vector)receiveObject(con);
	    if( v == null || v.size()==0 ) {
		System.out.println("Engine.getData: Null or empty result");
	    } else {
		data = (DataBlock)v.elementAt(0);
	    }
        } catch( Exception ex)  {
	    System.out.println("Engine.getData: "+ex);
	}
	
	return data;
    }

    
    public Vector getDocument(String id, String collection, String view)
    {
	Vector q = new Vector();
	Vector resp = new Vector();
	q.addElement("fetch");
	q.addElement(id);
	q.addElement(collection);
	q.addElement(view);

	try{
	    URLConnection con = getConnection();
	    sendObject(con,q);
	    resp = (Vector)receiveObject(con);
	} catch(Exception ex) {ex.printStackTrace();}
	return (Vector)resp.elementAt(0);
    }


    private URLConnection getConnection() throws IOException
    {
        URL u = new URL(servlet);
        URLConnection con = u.openConnection();
        con.setDoInput(true);
        con.setDoOutput(true);
        con.setUseCaches(false);
	con.setRequestProperty("Content-type","application/octet-stream");
        con.setAllowUserInteraction(false);
        return con;
    }
    
    
    private void sendObject(URLConnection con, Object obj) throws IOException {
        ObjectOutputStream out = new  ObjectOutputStream(con.getOutputStream());
        if( obj != null )
	    {
                out.writeObject(obj);
	    }
        out.close();
    }
    
    
    private Object receiveObject(URLConnection con) throws Exception
    {
	Object obj;
	InputStream is = con.getInputStream();
	ObjectInputStream in = new ObjectInputStream(con.getInputStream() );
	obj = in.readObject();
	in.close();
	return obj;
    }
}
