/**
 * @(#)ClusterGroupRect.java  12/12/99
 * @author Peter Au
 * All rights reserved.
 */
package vishnu.testvis.treemap.rectangle;

import vishnu.testvis.object.*;
import java.awt.*;
import java.awt.geom.AffineTransform;

public class ClusterGroupRect extends ZRect
{
  static final private Color __COLOUR=Color.black;
  private ClusterGroupObj _data;

  public ClusterGroupRect(float x1, float y1, float x2, float y2,
    Color c, ClusterGroupObj o)
  {
    super(x1,y1,x2,y2,c, o.getGroupSize());
    _data = o;
  }


  public ClusterGroupRect(float x1, float y1, float x2, float y2,ClusterGroupObj o)
  {
      super(x1,y1,x2,y2,__COLOUR, o.getGroupSize());
      _data = o;
  }



  public void paint(Graphics oldg)
  {
    Graphics2D g = (Graphics2D) oldg;
    centerText2(g,__COLOUR);
    g.setColor(__COLOUR);
    g.draw(getBounds2D());
  }


  public void paint(Graphics oldg, float f)
  {
    Graphics2D g = (Graphics2D) oldg;
    centerText2(g,__COLOUR);
    g.setColor(__COLOUR);
    paintBorder(oldg, f);
  }





  /**
   * !!! bug:- should check the boundary of the box and the length of the strings
   * display at most two labels on the centre of the rectangle
   * @param oldg is the display area
   * @param c is the colour
   */
  private void centerText(Graphics2D g, Color c)
  {
    String labels = _data.getLabels();

    if (labels!=null){
// Font f = new Font("Courier",Font.BOLD,12);
      Font f = g.getFont();
      FontMetrics fm = g.getFontMetrics(f);
      float ascent = (float) fm.getAscent();
      float height = (float) fm.getHeight();
      float x=getUpperLeftX(), y=getUpperLeftY(),w=(float)getWidth(), h=(float)getHeight();
      float width0=0F, width1=0F, x0=0F, x1=0F, y0=0F, y1=0F;

        g.setColor(c);
        width0 = (float) fm.stringWidth(labels);
        x0 = x + (w-width0)/2F;

// g.setFont(f);
//   AffineTransform transform
//     = AffineTransform.getRotateInstance(-90.0*Math.PI/180.0,100.0,50.0);
        g.drawString(labels,x0,y0);
        /*
        if (labels.length==1){
          y0 = y + (h-height)/2F + ascent;
          g.drawString(labels[0],x0,y0);
        }
        else
        {
          width1 = (float) fm.stringWidth(labels[1]);
          x1 = x + (w-width1)/2F;
          y0 = y + (h-(height*2F))/2F + ascent;
          y1 = y0 + (height*1F);
          g.drawString(labels[0],x0,y0);
          g.drawString(labels[1],x1,y1);
        }
        */
    }
  }  //-- centerText



AffineTransform transform;

  //-- pre: _data.getLabels() has at least 2 elements
  //-- post: draw two labels to the graphic
  private void centerText2(Graphics2D g, Color c)
  {
    String labels = _data.getLabels();
    if (labels!=null)
    {
      Font f;
      FontMetrics fm;
      int ascent, height;
      int x=(int) getUpperLeftX(), y=(int)getUpperLeftY(),
          w=(int) getWidth(),      h=(int)getHeight();
      int width0=0, width1=0, x0=0, x1=0, y0=0, y1=0;

      g.setColor(c);

      for (int fs=12; fs>=6; fs-=2)
	  {
        f = new Font("Dialog",Font.BOLD,fs);    // <--- Font for the labels

        fm = g.getFontMetrics(f);
        ascent = fm.getAscent();
        height = fm.getHeight();
        width0 = fm.stringWidth(labels);
        /*
        width0 = fm.stringWidth(labels[0]);
        width1 = fm.stringWidth(labels[1]);
        */
        //-- paint horizontally
        /*if (Math.max(width0,width1)<w  &&  2*height<h)*/
        if (width0<w  &&  height<h)
        {
          x0 = x + (w-width0)/2;
          //x1 = x + (w-width1)/2;
          y0 = y + (h-(height)) + ascent;
          //y1 = y0 + (height*1);
          g.setFont(f);
          g.drawString(labels,x0,y0);
          //g.drawString(labels[1],x1,y1);
 //System.err.println(labels[0] +", "+labels[1]+ " painted in font size: "+fs +"    horizontal!");

          break;
        }
        //-- paint vertically
/*
        else if (Math.max(width0,width1)<h  &&  2*height<w)
        {
          g.setFont(f);

          x0 = x + (w-width0)/2;
          x1 = x + (w-width1)/2;
          y0 = y + (h-(height*2))/2 + ascent;
          y1 = y0 + (height*1);
          g.setFont(f);
		  transform
     		= AffineTransform.getRotateInstance(-90.0*Math.PI/180.0,
                (double)(x+w)/2.0,(double)(y+h)/2.0);
		 g.setTransform(transform);
         System.err.println(transform.toString());

         g.drawString(labels[0],x0,y0);
         g.drawString(labels[1],x1,y1);
         System.err.println(labels[0] +", "+labels[1]+ " painted in font size: "+fs +"    vertical!");
         System.err.println("x: "+x+"  y: "+y+"  w: "+w+"  h: "+h );

         transform
            = AffineTransform.getRotateInstance(360.0*Math.PI/180.0,
               (double)(x+w)/2.0,(double)(y+h)/2.0);
         g.setTransform(transform);
         System.err.println(transform.toString());

         break;
        }
*/


      }  // for

    }  // if
  }  // centerText2
}
